package com.fp.persistence.parmas.param;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TARMREQUISITOPORTIPOTRAMITE*/
@Embeddable
public class TarmRequisitoPorTipoTramiteKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="CREQUISITO", nullable=false,updatable=false)

/**
* Codigo de requisito
*/
private String crequisito;

@Column(name="CTRAMITE", nullable=false,updatable=false)

/**
* null
*/
private Long ctramite;

/**Contructor por defecto*/
public TarmRequisitoPorTipoTramiteKey(){}
/**Contructor de TarmRequisitoPorTipoTramiteKey
@param pCrequisito Codigo de requisito
@param pCtramite null
*/
public TarmRequisitoPorTipoTramiteKey(String pCrequisito,Long pCtramite){
 crequisito=pCrequisito;
 ctramite=pCtramite;
}
/**Obtiene el valor de crequisito
@return valor de crequisito*/
public String getCrequisito(){
  return crequisito;
}
/**Fija el valor de crequisito
@param pCrequisito nuevo Valor de crequisito*/
public void setCrequisito(String pCrequisito){
  crequisito=pCrequisito;
}

/**Obtiene el valor de ctramite
@return valor de ctramite*/
public Long getCtramite(){
  return ctramite;
}
/**Fija el valor de ctramite
@param pCtramite nuevo Valor de ctramite*/
public void setCtramite(Long pCtramite){
  ctramite=pCtramite;
}

/**Implementacion de la comparacion de TarmRequisitoPorTipoTramiteKey
@param o Objeto de comparacion
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TarmRequisitoPorTipoTramiteKey))return false;
  TarmRequisitoPorTipoTramiteKey that = (TarmRequisitoPorTipoTramiteKey) o;
  if (this.getCrequisito() == null || that.getCrequisito() == null){
      return false;
  }
  if (! this.getCrequisito().equals(that.getCrequisito())){
    return false;
  }
  if (this.getCtramite() == null || that.getCtramite() == null){
      return false;
  }
  if (! this.getCtramite().equals(that.getCtramite())){
    return false;
  }
  return true;
}
/**Implementacion del metodo hashCode bajo el patron de Bloch
@return hashCode de la instancia TarmRequisitoPorTipoTramiteKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getCrequisito() == null ? 0 : this.getCrequisito().hashCode());
    result = result * 37 + (this.getCtramite() == null ? 0 : this.getCtramite().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
